// Generated by CoffeeScript 1.6.3
var coffeeDetected, coffeePrepare, coffeeStackRegex, fs, mapEvalOrigin, mapSourcePosition, nodeStackRegex, path, prettyPrint, structuredStackTrace, toJSON, wrapFrame;

Error._originalPrepareStackTrace = Error.prepareStackTrace;

fs = require('fs');

path = require('path');

mapSourcePosition = require('source-map-support').mapSourcePosition;

coffeePrepare = Error._originalPrepareStackTrace;

coffeeDetected = typeof coffeePrepare === 'function';

nodeStackRegex = /\n    at [^(]+ \((.*):(\d+):(\d+)\)/;

coffeeStackRegex = /\n  at [^(]+ \((.*):(\d+):(\d+), <js>/;

mapEvalOrigin = function(origin) {
  var match, position;
  match = /^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(origin);
  if (match) {
    position = mapSourcePosition({
      source: match[2],
      line: match[3],
      column: match[4]
    });
    return 'eval at ' + match[1] + ' (' + position.source + ':' + position.line + ':' + position.column + ')';
  }
  if (match = /^eval at ([^(]+) \((.+)\)$/.exec(origin)) {
    return 'eval at ' + match[1] + ' (' + (mapEvalOrigin(match[2])) + ')';
  }
  return origin;
};

wrapFrame = function(err, stack, frame) {
  var match, origin, position, source, _frame;
  if (coffeeDetected && (match = coffeeStackRegex.exec(coffeePrepare(err, [frame])))) {
    return _frame = {
      __proto__: frame,
      getFileName: function() {
        return match[1];
      },
      getLineNumber: function() {
        return match[2];
      },
      getColumnNumber: function() {
        return match[3] - 1;
      },
      getScriptNameOrSourceURL: function() {
        return match[1];
      }
    };
  }
  source = frame.getFileName() || frame.getScriptNameOrSourceURL();
  if (source) {
    position = mapSourcePosition({
      source: source,
      line: frame.getLineNumber(),
      column: frame.getColumnNumber()
    });
    return _frame = {
      __proto__: frame,
      getFileName: function() {
        return position.source;
      },
      getLineNumber: function() {
        return position.line;
      },
      getColumnNumber: function() {
        return position.column;
      },
      getScriptNameOrSourceURL: function() {
        return position.source;
      }
    };
  }
  origin = frame.isEval() && frame.getEvalOrigin();
  if (origin) {
    origin = mapEvalOrigin(origin);
    return _frame = {
      __proto__: frame,
      getEvalOrigin: function() {
        return origin;
      }
    };
  }
  return frame;
};

toJSON = function() {
  var result,
    _this = this;
  result = {};
  Object.keys(this).forEach(function(key) {
    var val;
    val = _this[key];
    if (key === 'toJSON') {

    } else if (key === 'this') {
      return result[key] = '' + val;
    } else if (typeof val === 'function') {
      return result[key] = '' + val;
    } else {
      return result[key] = _this[key];
    }
  });
  return result;
};

structuredStackTrace = function(err, stack) {
  var frame, _frame, _i, _len, _results;
  _results = [];
  for (_i = 0, _len = stack.length; _i < _len; _i++) {
    frame = stack[_i];
    _frame = Object.create({}, frame);
    _frame['this'] = frame.getThis();
    try {
      _frame.type = frame.getTypeName();
    } catch (_error) {
      err = _error;
      _frame.type = '';
    }
    _frame.isTop = frame.isToplevel();
    _frame.isEval = frame.isEval();
    _frame.origin = frame.getEvalOrigin();
    _frame.script = frame.getScriptNameOrSourceURL();
    _frame.fun = frame.getFunction();
    _frame.name = frame.getFunctionName();
    _frame.method = frame.getMethodName();
    _frame.path = frame.getFileName();
    _frame.line = frame.getLineNumber();
    _frame.col = frame.getColumnNumber();
    _frame.isNative = frame.isNative();
    _frame.pos = frame.getPosition();
    _frame.isCtor = frame.isConstructor();
    _frame.file = path.basename(frame.path);
    _frame.toJSON = toJSON;
    _results.push(_frame);
  }
  return _results;
};

prettyPrint = function(err, options) {
  var caret, data, line, match, position;
  if (options == null) {
    options = {};
  }
  if (options.colorize == null) {
    options.colorize = false;
  }
  match = nodeStackRegex.exec(err.stack);
  if (match == null) {
    match = coffeeStackRegex.exec(err.stack);
  }
  if ((match != null) && fs.existsSync(match[1])) {
    position = mapSourcePosition({
      source: match[1],
      line: match[2],
      column: match[3]
    });
    data = fs.readFileSync(position.source, 'utf8');
    if (line = data.split(/(?:\r\n|\r|\n)/)[position.line - 1]) {
      console.error(position.source + ':' + position.line);
      console.error(line);
      if (options.colorize) {
        caret = '\x1B[31m^\x1B[39m';
      } else {
        caret = '^';
      }
      console.error(((new Array(+position.column)).join(' ')) + caret);
    }
  }
  return console.error(err.stack);
};

module.exports = {
  patch: function(options) {
    if (options == null) {
      options = {};
    }
    if (options.handleUncaughtExceptions == null) {
      options.handleUncaughtExceptions = true;
    }
    if (options.handleUncaughtExceptions) {
      process.on('uncaughtException', function(err) {
        prettyPrint(err, {
          colorize: process.stdout.isTTY
        });
        return process.exit(1);
      });
    }
    return Error.prepareStackTrace = function(err, stack) {
      var frame;
      stack = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = stack.length; _i < _len; _i++) {
          frame = stack[_i];
          _results.push(wrapFrame(err, stack, frame));
        }
        return _results;
      })();
      err.structuredStackTrace = structuredStackTrace(err, stack);
      return err + (stack.map(function(frame) {
        return '\n    at ' + frame;
      })).join('');
    };
  },
  install: function() {
    return this.patch.apply(this, arguments);
  },
  mapEvalOrigin: mapEvalOrigin,
  mapSourcePosition: mapSourcePosition,
  structuredStackTrace: structuredStackTrace,
  wrapFrame: wrapFrame,
  prettyPrint: prettyPrint
};

/*
//@ sourceMappingURL=index.map
*/
